<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfFacilityInfoTypeGuestRoom ArrayType
 * @subpackage Arrays
 */
class ArrayOfFacilityInfoTypeGuestRoom extends AbstractStructArrayBase
{
    /**
     * The GuestRoom
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\GuestRoom[]
     */
    public $GuestRoom;
    /**
     * Constructor method for ArrayOfFacilityInfoTypeGuestRoom
     * @uses ArrayOfFacilityInfoTypeGuestRoom::setGuestRoom()
     * @param \StructType\GuestRoom[] $guestRoom
     */
    public function __construct(array $guestRoom = array())
    {
        $this
            ->setGuestRoom($guestRoom);
    }
    /**
     * Get GuestRoom value
     * @return \StructType\GuestRoom[]|null
     */
    public function getGuestRoom()
    {
        return $this->GuestRoom;
    }
    /**
     * This method is responsible for validating the values passed to the setGuestRoom method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGuestRoom method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGuestRoomForArrayConstraintsFromSetGuestRoom(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfFacilityInfoTypeGuestRoomGuestRoomItem) {
            // validation for constraint: itemType
            if (!$arrayOfFacilityInfoTypeGuestRoomGuestRoomItem instanceof \StructType\GuestRoom) {
                $invalidValues[] = is_object($arrayOfFacilityInfoTypeGuestRoomGuestRoomItem) ? get_class($arrayOfFacilityInfoTypeGuestRoomGuestRoomItem) : sprintf('%s(%s)', gettype($arrayOfFacilityInfoTypeGuestRoomGuestRoomItem), var_export($arrayOfFacilityInfoTypeGuestRoomGuestRoomItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GuestRoom property can only contain items of type \StructType\GuestRoom, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GuestRoom value
     * @throws \InvalidArgumentException
     * @param \StructType\GuestRoom[] $guestRoom
     * @return \ArrayType\ArrayOfFacilityInfoTypeGuestRoom
     */
    public function setGuestRoom(array $guestRoom = array())
    {
        // validation for constraint: array
        if ('' !== ($guestRoomArrayErrorMessage = self::validateGuestRoomForArrayConstraintsFromSetGuestRoom($guestRoom))) {
            throw new \InvalidArgumentException($guestRoomArrayErrorMessage, __LINE__);
        }
        $this->GuestRoom = $guestRoom;
        return $this;
    }
    /**
     * Add item to GuestRoom value
     * @throws \InvalidArgumentException
     * @param \StructType\GuestRoom $item
     * @return \ArrayType\ArrayOfFacilityInfoTypeGuestRoom
     */
    public function addToGuestRoom(\StructType\GuestRoom $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GuestRoom) {
            throw new \InvalidArgumentException(sprintf('The GuestRoom property can only contain items of type \StructType\GuestRoom, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GuestRoom[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GuestRoom|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GuestRoom|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GuestRoom|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GuestRoom|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GuestRoom|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GuestRoom
     */
    public function getAttributeName()
    {
        return 'GuestRoom';
    }
}
