<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHotelRatePlanTypeDestinationSystemCode ArrayType
 * @subpackage Arrays
 */
class ArrayOfHotelRatePlanTypeDestinationSystemCode extends AbstractStructArrayBase
{
    /**
     * The DestinationSystemCode
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\DestinationSystemCode[]
     */
    public $DestinationSystemCode;
    /**
     * Constructor method for ArrayOfHotelRatePlanTypeDestinationSystemCode
     * @uses ArrayOfHotelRatePlanTypeDestinationSystemCode::setDestinationSystemCode()
     * @param \StructType\DestinationSystemCode[] $destinationSystemCode
     */
    public function __construct(array $destinationSystemCode = array())
    {
        $this
            ->setDestinationSystemCode($destinationSystemCode);
    }
    /**
     * Get DestinationSystemCode value
     * @return \StructType\DestinationSystemCode[]|null
     */
    public function getDestinationSystemCode()
    {
        return $this->DestinationSystemCode;
    }
    /**
     * This method is responsible for validating the values passed to the setDestinationSystemCode method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDestinationSystemCode method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDestinationSystemCodeForArrayConstraintsFromSetDestinationSystemCode(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfHotelRatePlanTypeDestinationSystemCodeDestinationSystemCodeItem) {
            // validation for constraint: itemType
            if (!$arrayOfHotelRatePlanTypeDestinationSystemCodeDestinationSystemCodeItem instanceof \StructType\DestinationSystemCode) {
                $invalidValues[] = is_object($arrayOfHotelRatePlanTypeDestinationSystemCodeDestinationSystemCodeItem) ? get_class($arrayOfHotelRatePlanTypeDestinationSystemCodeDestinationSystemCodeItem) : sprintf('%s(%s)', gettype($arrayOfHotelRatePlanTypeDestinationSystemCodeDestinationSystemCodeItem), var_export($arrayOfHotelRatePlanTypeDestinationSystemCodeDestinationSystemCodeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DestinationSystemCode property can only contain items of type \StructType\DestinationSystemCode, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DestinationSystemCode value
     * @throws \InvalidArgumentException
     * @param \StructType\DestinationSystemCode[] $destinationSystemCode
     * @return \ArrayType\ArrayOfHotelRatePlanTypeDestinationSystemCode
     */
    public function setDestinationSystemCode(array $destinationSystemCode = array())
    {
        // validation for constraint: array
        if ('' !== ($destinationSystemCodeArrayErrorMessage = self::validateDestinationSystemCodeForArrayConstraintsFromSetDestinationSystemCode($destinationSystemCode))) {
            throw new \InvalidArgumentException($destinationSystemCodeArrayErrorMessage, __LINE__);
        }
        $this->DestinationSystemCode = $destinationSystemCode;
        return $this;
    }
    /**
     * Add item to DestinationSystemCode value
     * @throws \InvalidArgumentException
     * @param \StructType\DestinationSystemCode $item
     * @return \ArrayType\ArrayOfHotelRatePlanTypeDestinationSystemCode
     */
    public function addToDestinationSystemCode(\StructType\DestinationSystemCode $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DestinationSystemCode) {
            throw new \InvalidArgumentException(sprintf('The DestinationSystemCode property can only contain items of type \StructType\DestinationSystemCode, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DestinationSystemCode[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DestinationSystemCode|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DestinationSystemCode|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DestinationSystemCode|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DestinationSystemCode|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DestinationSystemCode|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DestinationSystemCode
     */
    public function getAttributeName()
    {
        return 'DestinationSystemCode';
    }
}
