<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHotelReservationIDsTypeHotelReservationID ArrayType
 * @subpackage Arrays
 */
class ArrayOfHotelReservationIDsTypeHotelReservationID extends AbstractStructArrayBase
{
    /**
     * The HotelReservationID
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\HotelReservationID[]
     */
    public $HotelReservationID;
    /**
     * Constructor method for ArrayOfHotelReservationIDsTypeHotelReservationID
     * @uses ArrayOfHotelReservationIDsTypeHotelReservationID::setHotelReservationID()
     * @param \StructType\HotelReservationID[] $hotelReservationID
     */
    public function __construct(array $hotelReservationID = array())
    {
        $this
            ->setHotelReservationID($hotelReservationID);
    }
    /**
     * Get HotelReservationID value
     * @return \StructType\HotelReservationID[]|null
     */
    public function getHotelReservationID()
    {
        return $this->HotelReservationID;
    }
    /**
     * This method is responsible for validating the values passed to the setHotelReservationID method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHotelReservationID method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHotelReservationIDForArrayConstraintsFromSetHotelReservationID(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfHotelReservationIDsTypeHotelReservationIDHotelReservationIDItem) {
            // validation for constraint: itemType
            if (!$arrayOfHotelReservationIDsTypeHotelReservationIDHotelReservationIDItem instanceof \StructType\HotelReservationID) {
                $invalidValues[] = is_object($arrayOfHotelReservationIDsTypeHotelReservationIDHotelReservationIDItem) ? get_class($arrayOfHotelReservationIDsTypeHotelReservationIDHotelReservationIDItem) : sprintf('%s(%s)', gettype($arrayOfHotelReservationIDsTypeHotelReservationIDHotelReservationIDItem), var_export($arrayOfHotelReservationIDsTypeHotelReservationIDHotelReservationIDItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The HotelReservationID property can only contain items of type \StructType\HotelReservationID, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set HotelReservationID value
     * @throws \InvalidArgumentException
     * @param \StructType\HotelReservationID[] $hotelReservationID
     * @return \ArrayType\ArrayOfHotelReservationIDsTypeHotelReservationID
     */
    public function setHotelReservationID(array $hotelReservationID = array())
    {
        // validation for constraint: array
        if ('' !== ($hotelReservationIDArrayErrorMessage = self::validateHotelReservationIDForArrayConstraintsFromSetHotelReservationID($hotelReservationID))) {
            throw new \InvalidArgumentException($hotelReservationIDArrayErrorMessage, __LINE__);
        }
        $this->HotelReservationID = $hotelReservationID;
        return $this;
    }
    /**
     * Add item to HotelReservationID value
     * @throws \InvalidArgumentException
     * @param \StructType\HotelReservationID $item
     * @return \ArrayType\ArrayOfHotelReservationIDsTypeHotelReservationID
     */
    public function addToHotelReservationID(\StructType\HotelReservationID $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\HotelReservationID) {
            throw new \InvalidArgumentException(sprintf('The HotelReservationID property can only contain items of type \StructType\HotelReservationID, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->HotelReservationID[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\HotelReservationID|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\HotelReservationID|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\HotelReservationID|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\HotelReservationID|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\HotelReservationID|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HotelReservationID
     */
    public function getAttributeName()
    {
        return 'HotelReservationID';
    }
}
