<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInvBlockTypeBlockDescription ArrayType
 * @subpackage Arrays
 */
class ArrayOfInvBlockTypeBlockDescription extends AbstractStructArrayBase
{
    /**
     * The BlockDescription
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\BlockDescription[]
     */
    public $BlockDescription;
    /**
     * Constructor method for ArrayOfInvBlockTypeBlockDescription
     * @uses ArrayOfInvBlockTypeBlockDescription::setBlockDescription()
     * @param \StructType\BlockDescription[] $blockDescription
     */
    public function __construct(array $blockDescription = array())
    {
        $this
            ->setBlockDescription($blockDescription);
    }
    /**
     * Get BlockDescription value
     * @return \StructType\BlockDescription[]|null
     */
    public function getBlockDescription()
    {
        return $this->BlockDescription;
    }
    /**
     * This method is responsible for validating the values passed to the setBlockDescription method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBlockDescription method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBlockDescriptionForArrayConstraintsFromSetBlockDescription(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInvBlockTypeBlockDescriptionBlockDescriptionItem) {
            // validation for constraint: itemType
            if (!$arrayOfInvBlockTypeBlockDescriptionBlockDescriptionItem instanceof \StructType\BlockDescription) {
                $invalidValues[] = is_object($arrayOfInvBlockTypeBlockDescriptionBlockDescriptionItem) ? get_class($arrayOfInvBlockTypeBlockDescriptionBlockDescriptionItem) : sprintf('%s(%s)', gettype($arrayOfInvBlockTypeBlockDescriptionBlockDescriptionItem), var_export($arrayOfInvBlockTypeBlockDescriptionBlockDescriptionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BlockDescription property can only contain items of type \StructType\BlockDescription, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BlockDescription value
     * @throws \InvalidArgumentException
     * @param \StructType\BlockDescription[] $blockDescription
     * @return \ArrayType\ArrayOfInvBlockTypeBlockDescription
     */
    public function setBlockDescription(array $blockDescription = array())
    {
        // validation for constraint: array
        if ('' !== ($blockDescriptionArrayErrorMessage = self::validateBlockDescriptionForArrayConstraintsFromSetBlockDescription($blockDescription))) {
            throw new \InvalidArgumentException($blockDescriptionArrayErrorMessage, __LINE__);
        }
        $this->BlockDescription = $blockDescription;
        return $this;
    }
    /**
     * Add item to BlockDescription value
     * @throws \InvalidArgumentException
     * @param \StructType\BlockDescription $item
     * @return \ArrayType\ArrayOfInvBlockTypeBlockDescription
     */
    public function addToBlockDescription(\StructType\BlockDescription $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BlockDescription) {
            throw new \InvalidArgumentException(sprintf('The BlockDescription property can only contain items of type \StructType\BlockDescription, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BlockDescription[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\BlockDescription|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\BlockDescription|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\BlockDescription|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\BlockDescription|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\BlockDescription|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string BlockDescription
     */
    public function getAttributeName()
    {
        return 'BlockDescription';
    }
}
