<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSellableProductsTypeSellableProduct ArrayType
 * @subpackage Arrays
 */
class ArrayOfSellableProductsTypeSellableProduct extends AbstractStructArrayBase
{
    /**
     * The SellableProduct
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SellableProduct[]
     */
    public $SellableProduct;
    /**
     * Constructor method for ArrayOfSellableProductsTypeSellableProduct
     * @uses ArrayOfSellableProductsTypeSellableProduct::setSellableProduct()
     * @param \StructType\SellableProduct[] $sellableProduct
     */
    public function __construct(array $sellableProduct = array())
    {
        $this
            ->setSellableProduct($sellableProduct);
    }
    /**
     * Get SellableProduct value
     * @return \StructType\SellableProduct[]|null
     */
    public function getSellableProduct()
    {
        return $this->SellableProduct;
    }
    /**
     * This method is responsible for validating the values passed to the setSellableProduct method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSellableProduct method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSellableProductForArrayConstraintsFromSetSellableProduct(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSellableProductsTypeSellableProductSellableProductItem) {
            // validation for constraint: itemType
            if (!$arrayOfSellableProductsTypeSellableProductSellableProductItem instanceof \StructType\SellableProduct) {
                $invalidValues[] = is_object($arrayOfSellableProductsTypeSellableProductSellableProductItem) ? get_class($arrayOfSellableProductsTypeSellableProductSellableProductItem) : sprintf('%s(%s)', gettype($arrayOfSellableProductsTypeSellableProductSellableProductItem), var_export($arrayOfSellableProductsTypeSellableProductSellableProductItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SellableProduct property can only contain items of type \StructType\SellableProduct, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SellableProduct value
     * @throws \InvalidArgumentException
     * @param \StructType\SellableProduct[] $sellableProduct
     * @return \ArrayType\ArrayOfSellableProductsTypeSellableProduct
     */
    public function setSellableProduct(array $sellableProduct = array())
    {
        // validation for constraint: array
        if ('' !== ($sellableProductArrayErrorMessage = self::validateSellableProductForArrayConstraintsFromSetSellableProduct($sellableProduct))) {
            throw new \InvalidArgumentException($sellableProductArrayErrorMessage, __LINE__);
        }
        $this->SellableProduct = $sellableProduct;
        return $this;
    }
    /**
     * Add item to SellableProduct value
     * @throws \InvalidArgumentException
     * @param \StructType\SellableProduct $item
     * @return \ArrayType\ArrayOfSellableProductsTypeSellableProduct
     */
    public function addToSellableProduct(\StructType\SellableProduct $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SellableProduct) {
            throw new \InvalidArgumentException(sprintf('The SellableProduct property can only contain items of type \StructType\SellableProduct, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SellableProduct[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SellableProduct|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SellableProduct|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SellableProduct|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SellableProduct|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SellableProduct|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SellableProduct
     */
    public function getAttributeName()
    {
        return 'SellableProduct';
    }
}
