<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContactInfo StructType
 * @subpackage Structs
 */
class ContactInfo extends AbstractStructBase
{
    /**
     * The SendData
     * @var bool
     */
    public $SendData;
    /**
     * Constructor method for ContactInfo
     * @uses ContactInfo::setSendData()
     * @param bool $sendData
     */
    public function __construct($sendData = null)
    {
        $this
            ->setSendData($sendData);
    }
    /**
     * Get SendData value
     * @return bool|null
     */
    public function getSendData()
    {
        return $this->SendData;
    }
    /**
     * Set SendData value
     * @param bool $sendData
     * @return \StructType\ContactInfo
     */
    public function setSendData($sendData = null)
    {
        // validation for constraint: boolean
        if (!is_null($sendData) && !is_bool($sendData)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($sendData, true), gettype($sendData)), __LINE__);
        }
        $this->SendData = $sendData;
        return $this;
    }
}
