<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HotelSearchCriteriaType StructType
 * @subpackage Structs
 */
class HotelSearchCriteriaType extends AbstractStructBase
{
    /**
     * The Criterion
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Criterion[]
     */
    public $Criterion;
    /**
     * Constructor method for HotelSearchCriteriaType
     * @uses HotelSearchCriteriaType::setCriterion()
     * @param \StructType\Criterion[] $criterion
     */
    public function __construct(array $criterion = array())
    {
        $this
            ->setCriterion($criterion);
    }
    /**
     * Get Criterion value
     * @return \StructType\Criterion[]|null
     */
    public function getCriterion()
    {
        return $this->Criterion;
    }
    /**
     * This method is responsible for validating the values passed to the setCriterion method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCriterion method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCriterionForArrayConstraintsFromSetCriterion(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $hotelSearchCriteriaTypeCriterionItem) {
            // validation for constraint: itemType
            if (!$hotelSearchCriteriaTypeCriterionItem instanceof \StructType\Criterion) {
                $invalidValues[] = is_object($hotelSearchCriteriaTypeCriterionItem) ? get_class($hotelSearchCriteriaTypeCriterionItem) : sprintf('%s(%s)', gettype($hotelSearchCriteriaTypeCriterionItem), var_export($hotelSearchCriteriaTypeCriterionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Criterion property can only contain items of type \StructType\Criterion, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Criterion value
     * @throws \InvalidArgumentException
     * @param \StructType\Criterion[] $criterion
     * @return \StructType\HotelSearchCriteriaType
     */
    public function setCriterion(array $criterion = array())
    {
        // validation for constraint: array
        if ('' !== ($criterionArrayErrorMessage = self::validateCriterionForArrayConstraintsFromSetCriterion($criterion))) {
            throw new \InvalidArgumentException($criterionArrayErrorMessage, __LINE__);
        }
        $this->Criterion = $criterion;
        return $this;
    }
    /**
     * Add item to Criterion value
     * @throws \InvalidArgumentException
     * @param \StructType\Criterion $item
     * @return \StructType\HotelSearchCriteriaType
     */
    public function addToCriterion(\StructType\Criterion $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Criterion) {
            throw new \InvalidArgumentException(sprintf('The Criterion property can only contain items of type \StructType\Criterion, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Criterion[] = $item;
        return $this;
    }
}
