<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InvBlockCodeRefs StructType
 * @subpackage Structs
 */
class InvBlockCodeRefs extends InvBlockCodeRefType
{
    /**
     * The InvBlockCodeRef
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\InvBlockCodeRefType[]
     */
    public $InvBlockCodeRef;
    /**
     * Constructor method for InvBlockCodeRefs
     * @uses InvBlockCodeRefs::setInvBlockCodeRef()
     * @param \StructType\InvBlockCodeRefType[] $invBlockCodeRef
     */
    public function __construct(array $invBlockCodeRef = array())
    {
        $this
            ->setInvBlockCodeRef($invBlockCodeRef);
    }
    /**
     * Get InvBlockCodeRef value
     * @return \StructType\InvBlockCodeRefType[]|null
     */
    public function getInvBlockCodeRef()
    {
        return $this->InvBlockCodeRef;
    }
    /**
     * This method is responsible for validating the values passed to the setInvBlockCodeRef method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInvBlockCodeRef method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInvBlockCodeRefForArrayConstraintsFromSetInvBlockCodeRef(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $invBlockCodeRefsInvBlockCodeRefItem) {
            // validation for constraint: itemType
            if (!$invBlockCodeRefsInvBlockCodeRefItem instanceof \StructType\InvBlockCodeRefType) {
                $invalidValues[] = is_object($invBlockCodeRefsInvBlockCodeRefItem) ? get_class($invBlockCodeRefsInvBlockCodeRefItem) : sprintf('%s(%s)', gettype($invBlockCodeRefsInvBlockCodeRefItem), var_export($invBlockCodeRefsInvBlockCodeRefItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InvBlockCodeRef property can only contain items of type \StructType\InvBlockCodeRefType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InvBlockCodeRef value
     * @throws \InvalidArgumentException
     * @param \StructType\InvBlockCodeRefType[] $invBlockCodeRef
     * @return \StructType\InvBlockCodeRefs
     */
    public function setInvBlockCodeRef(array $invBlockCodeRef = array())
    {
        // validation for constraint: array
        if ('' !== ($invBlockCodeRefArrayErrorMessage = self::validateInvBlockCodeRefForArrayConstraintsFromSetInvBlockCodeRef($invBlockCodeRef))) {
            throw new \InvalidArgumentException($invBlockCodeRefArrayErrorMessage, __LINE__);
        }
        $this->InvBlockCodeRef = $invBlockCodeRef;
        return $this;
    }
    /**
     * Add item to InvBlockCodeRef value
     * @throws \InvalidArgumentException
     * @param \StructType\InvBlockCodeRefType $item
     * @return \StructType\InvBlockCodeRefs
     */
    public function addToInvBlockCodeRef(\StructType\InvBlockCodeRefType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InvBlockCodeRefType) {
            throw new \InvalidArgumentException(sprintf('The InvBlockCodeRef property can only contain items of type \StructType\InvBlockCodeRefType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InvBlockCodeRef[] = $item;
        return $this;
    }
}
