<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OTA_HotelDescriptiveInfoRS StructType
 * @subpackage Structs
 */
class OTA_HotelDescriptiveInfoRS extends AbstractStructBase
{
    /**
     * The Errors
     * Meta information extracted from the WSDL
     * - choice: Errors | HotelDescriptiveContents | Success | Warnings
     * - choiceMaxOccurs: unbounded
     * - choiceMinOccurs: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ErrorsType
     */
    public $Errors;
    /**
     * The HotelDescriptiveContents
     * Meta information extracted from the WSDL
     * - choice: Errors | HotelDescriptiveContents | Success | Warnings
     * - choiceMaxOccurs: unbounded
     * - choiceMinOccurs: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\HotelDescriptiveContents
     */
    public $HotelDescriptiveContents;
    /**
     * The Success
     * Meta information extracted from the WSDL
     * - choice: Errors | HotelDescriptiveContents | Success | Warnings
     * - choiceMaxOccurs: unbounded
     * - choiceMinOccurs: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\SuccessType
     */
    public $Success;
    /**
     * The Warnings
     * Meta information extracted from the WSDL
     * - choice: Errors | HotelDescriptiveContents | Success | Warnings
     * - choiceMaxOccurs: unbounded
     * - choiceMinOccurs: 0
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\WarningsType
     */
    public $Warnings;
    /**
     * Constructor method for OTA_HotelDescriptiveInfoRS
     * @uses OTA_HotelDescriptiveInfoRS::setErrors()
     * @uses OTA_HotelDescriptiveInfoRS::setHotelDescriptiveContents()
     * @uses OTA_HotelDescriptiveInfoRS::setSuccess()
     * @uses OTA_HotelDescriptiveInfoRS::setWarnings()
     * @param \StructType\ErrorsType $errors
     * @param \StructType\HotelDescriptiveContents $hotelDescriptiveContents
     * @param \StructType\SuccessType $success
     * @param \StructType\WarningsType $warnings
     */
    public function __construct(\StructType\ErrorsType $errors = null, \StructType\HotelDescriptiveContents $hotelDescriptiveContents = null, \StructType\SuccessType $success = null, \StructType\WarningsType $warnings = null)
    {
        $this
            ->setErrors($errors)
            ->setHotelDescriptiveContents($hotelDescriptiveContents)
            ->setSuccess($success)
            ->setWarnings($warnings);
    }
    /**
     * Get Errors value
     * @return \StructType\ErrorsType|null
     */
    public function getErrors()
    {
        return isset($this->Errors) ? $this->Errors : null;
    }
    /**
     * This method is responsible for validating the value passed to the setErrors method
     * This method is willingly generated in order to preserve the one-line inline validation within the setErrors method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateErrorsForChoiceConstraintsFromSetErrors($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'HotelDescriptiveContents',
            'Success',
            'Warnings',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property Errors can\'t be set as the property %s is already set. Only one property must be set among these properties: Errors, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set Errors value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ErrorsType $errors
     * @return \StructType\OTA_HotelDescriptiveInfoRS
     */
    public function setErrors(\StructType\ErrorsType $errors = null)
    {
        // validation for constraint: choice(Errors, HotelDescriptiveContents, Success, Warnings)
        if ('' !== ($errorsChoiceErrorMessage = self::validateErrorsForChoiceConstraintsFromSetErrors($errors))) {
            throw new \InvalidArgumentException($errorsChoiceErrorMessage, __LINE__);
        }
        if (is_null($errors) || (is_array($errors) && empty($errors))) {
            unset($this->Errors);
        } else {
            $this->Errors = $errors;
        }
        return $this;
    }
    /**
     * Get HotelDescriptiveContents value
     * @return \StructType\HotelDescriptiveContents|null
     */
    public function getHotelDescriptiveContents()
    {
        return isset($this->HotelDescriptiveContents) ? $this->HotelDescriptiveContents : null;
    }
    /**
     * This method is responsible for validating the value passed to the setHotelDescriptiveContents method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHotelDescriptiveContents method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateHotelDescriptiveContentsForChoiceConstraintsFromSetHotelDescriptiveContents($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'Errors',
            'Success',
            'Warnings',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property HotelDescriptiveContents can\'t be set as the property %s is already set. Only one property must be set among these properties: HotelDescriptiveContents, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set HotelDescriptiveContents value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\HotelDescriptiveContents $hotelDescriptiveContents
     * @return \StructType\OTA_HotelDescriptiveInfoRS
     */
    public function setHotelDescriptiveContents(\StructType\HotelDescriptiveContents $hotelDescriptiveContents = null)
    {
        // validation for constraint: choice(Errors, HotelDescriptiveContents, Success, Warnings)
        if ('' !== ($hotelDescriptiveContentsChoiceErrorMessage = self::validateHotelDescriptiveContentsForChoiceConstraintsFromSetHotelDescriptiveContents($hotelDescriptiveContents))) {
            throw new \InvalidArgumentException($hotelDescriptiveContentsChoiceErrorMessage, __LINE__);
        }
        if (is_null($hotelDescriptiveContents) || (is_array($hotelDescriptiveContents) && empty($hotelDescriptiveContents))) {
            unset($this->HotelDescriptiveContents);
        } else {
            $this->HotelDescriptiveContents = $hotelDescriptiveContents;
        }
        return $this;
    }
    /**
     * Get Success value
     * @return \StructType\SuccessType|null
     */
    public function getSuccess()
    {
        return isset($this->Success) ? $this->Success : null;
    }
    /**
     * This method is responsible for validating the value passed to the setSuccess method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSuccess method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateSuccessForChoiceConstraintsFromSetSuccess($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'Errors',
            'HotelDescriptiveContents',
            'Warnings',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property Success can\'t be set as the property %s is already set. Only one property must be set among these properties: Success, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set Success value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SuccessType $success
     * @return \StructType\OTA_HotelDescriptiveInfoRS
     */
    public function setSuccess(\StructType\SuccessType $success = null)
    {
        // validation for constraint: choice(Errors, HotelDescriptiveContents, Success, Warnings)
        if ('' !== ($successChoiceErrorMessage = self::validateSuccessForChoiceConstraintsFromSetSuccess($success))) {
            throw new \InvalidArgumentException($successChoiceErrorMessage, __LINE__);
        }
        if (is_null($success) || (is_array($success) && empty($success))) {
            unset($this->Success);
        } else {
            $this->Success = $success;
        }
        return $this;
    }
    /**
     * Get Warnings value
     * @return \StructType\WarningsType|null
     */
    public function getWarnings()
    {
        return isset($this->Warnings) ? $this->Warnings : null;
    }
    /**
     * This method is responsible for validating the value passed to the setWarnings method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWarnings method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateWarningsForChoiceConstraintsFromSetWarnings($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'Errors',
            'HotelDescriptiveContents',
            'Success',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property Warnings can\'t be set as the property %s is already set. Only one property must be set among these properties: Warnings, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set Warnings value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WarningsType $warnings
     * @return \StructType\OTA_HotelDescriptiveInfoRS
     */
    public function setWarnings(\StructType\WarningsType $warnings = null)
    {
        // validation for constraint: choice(Errors, HotelDescriptiveContents, Success, Warnings)
        if ('' !== ($warningsChoiceErrorMessage = self::validateWarningsForChoiceConstraintsFromSetWarnings($warnings))) {
            throw new \InvalidArgumentException($warningsChoiceErrorMessage, __LINE__);
        }
        if (is_null($warnings) || (is_array($warnings) && empty($warnings))) {
            unset($this->Warnings);
        } else {
            $this->Warnings = $warnings;
        }
        return $this;
    }
}
